#regular projectile movement
execute as @e[tag=projectile] at @s run function wasd.lib:math/projectile/control
#bouncing projectile movement
execute as @e[tag=bouncing_projectile] at @s run function wasd.lib:math/bouncing_projectile/control


#affects
#honey slowed
execute as @e[scores={honey_slow_timer=1..}] at @s run function wasd.lib:affects/honey_slowed

#bleeding
execute as @e[tag=wasd.bleeding] at @s run function wasd.lib:affects/bleeding

#frozen
execute as @e[tag=frozen] at @s run function wasd.lib:affects/frozen

#electric stunned
tag @a[tag=zap_immune] remove electric_stunned
execute as @e[tag=electric_stunned] at @s run function wasd.lib:affects/electric_stun

#generic stunn
execute as @e[tag=generic_stunned,tag=!global.ignore] at @s run function wasd.lib:affects/generic_stun



#click event handling
execute as @a at @s if score @s wasd.clickevent matches 1.. run function wasd.lib:util/click_event
scoreboard players remove @a[scores={click_cooldown=1..}] click_cooldown 1
execute as @a at @s unless score @s click_cooldown matches 0.. run scoreboard players set @s click_cooldown 0

#Detect playing joining the world.
execute as @a[scores={join_world=1..}] run function wasd.lib:util/packs

#fake gravity
execute as @e[tag=wasd.has_gravity] at @s run function wasd.lib:math/gravity
execute as @e[tag=wasd.has_gravity_head] at @s run function wasd.lib:math/gravity_head

#create crafter (if enabled)
execute if score wasd.crafter wasd.lib_setting matches 1 as @a at @s as @e[type=item,tag=!global.ignore,tag=!wasd.not_crafting_table,distance=..7] unless entity @s[nbt={Item:{id:"minecraft:crafting_table",Count:1b}}] run tag @s add wasd.not_crafting_table
execute if score wasd.crafter wasd.lib_setting matches 1 as @a at @s as @e[type=item,tag=!global.ignore,tag=!wasd.not_crafting_table,distance=..7] at @s run function wasd.lib:crafter/detect
execute as @e[tag=wasd.custom_crafter] at @s run function wasd.lib:crafter/crafter

#dropped item motion
execute as @e[tag=wasd.dropped_item] if entity @s[nbt={Age:3s}] at @s run function wasd.lib:util/drop_held_item_motion

#lib powered button reset
execute as @e[tag=lib.powered_button] at @s run function wasd.lib:power/powered_button
#lib powered pressure plate reset
execute as @e[tag=lib.powered_pressure_plate] at @s run function wasd.lib:power/powered_pressure_plate


#trigger patron list
execute as @a[scores={wasd.patrons=1..}] run function wasd.lib:util/patrons


#frozen
execute as @e[tag=wasd.rainbow_dancing] at @s run function wasd.lib:affects/rainbow_dancing

#reset elytra fly
scoreboard players reset @a[scores={wasd.fly=1..}] wasd.fly